/*
 * Copyright (C) 2013 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VN_USERS_H
#define VN_USERS_H

#include <vn/vn.h>

#define VN_TYPE_USERS		(vn_users_get_type ())
#define VN_USERS(obj)		(G_TYPE_CHECK_INSTANCE_CAST (obj, VN_TYPE_USERS, VnUsers))
#define VN_IS_USERS(obj)	(G_TYPE_CHECK_INSTANCE_TYPE (obj, VN_TYPE_USERS))

typedef struct _VnUsers VnUsers;
typedef struct _VnUsersClass VnUsersClass;

struct _VnUsers
{
	VnForm parent;
	GvnParam * user_id;
	DbIterator * account;
	DbIterator * alias;
	DbIterator * sip;
	GtkDialog * password_dialog;
	GtkEntry * password_entry;
	GtkEntry * repeat_password;
};

struct _VnUsersClass
{
	VnFormClass parent;
};

GType	vn_users_get_type	();

#endif