/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SQL_DML_H
#define SQL_DML_H

#include "sql-stmt.h"
#include "sql-expr.h"
#include "sql-target.h"

#define SQL_TYPE_DML			(sql_dml_get_type ())
#define SQL_DML(obj)			(G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_TYPE_DML, SqlDml))
#define SQL_IS_DML(obj)			(G_TYPE_CHECK_INSTANCE_TYPE (obj, SQL_TYPE_DML))

typedef struct _SqlDml SqlDml;
typedef struct _SqlDmlClass SqlDmlClass;

/**
 * SqlDml:
 * @target: (element-type Sql.Target): list of targets for the DML query
 * @where: an #SqlExpr
 **/
struct _SqlDml
{
	SqlStmt parent;
	SqlList * targets;
	SqlExpr * where;
};

struct _SqlDmlClass
{
	/* <private> */
	SqlStmtClass parent;
};

GType	sql_dml_get_type		();
void	sql_dml_set_where		(SqlDml * obj, SqlExpr * expr);

#endif
