/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SQL_FIELD_H
#define SQL_FIELD_H

#include "sql-expr.h"
#include "sql-target.h"

#define SQL_TYPE_FIELD		(sql_field_get_type ())
#define SQL_FIELD(object)	(G_TYPE_CHECK_INSTANCE_CAST (object, SQL_TYPE_FIELD, SqlField))
#define SQL_IS_FIELD(obj)	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_FIELD))

typedef struct _SqlField SqlField;
typedef struct _SqlFieldClass SqlFieldClass;

struct _SqlField
{
	SqlExpr parent;
	gchar * name;
	gchar * target;
	gchar * schema;
};

struct _SqlFieldClass
{
	/* <private> */
	SqlExprClass parent;
};

GType		sql_field_get_type		();
SqlObject *	sql_field_new			(const gchar * name
									,const gchar * target
									,const gchar * schema);
void		sql_field_set_name		(SqlField * obj, const gchar * name);

#endif
