/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SQL_STRING_H
#define SQL_STRING_H

#include <gvn/gvn-param.h>
#include <gvn/gvn-value.h>
#include "sql-stmt.h"
#include "sql-value.h"

#define SQL_TYPE_STRING		(sql_string_get_type ())
#define SQL_IS_STRING(obj)	(G_TYPE_CHECK_INSTANCE_TYPE (obj, SQL_TYPE_STRING))
#define SQL_STRING(obj)		(G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_TYPE_STRING, SqlString))

typedef struct _SqlString SqlString;
typedef struct _SqlStringClass SqlStringClass;

/**
 * SqlString:
 * @expr: (element-type Sql.Expr):
 **/
struct _SqlString
{
	SqlStmt parent;
	gchar * sql;
	GSList * holders;
};

struct _SqlStringClass
{
	/* <private> */
	SqlStmtClass parent;
};

GType		sql_string_get_type		();
SqlString *	sql_string_new			(const gchar * sql);
void		sql_string_add_param	(SqlString * obj, const gchar * id, GvnParam * param);
void		sql_string_add_value	(SqlString * obj, const gchar * id, GType type, gpointer content);

#endif
