/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SQL_VALUE_H
#define SQL_VALUE_H

#include <gvn/gvn-param.h>
#include "sql-expr.h"

#define SQL_TYPE_VALUE		(sql_value_get_type ())
#define SQL_VALUE(obj)		(G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_TYPE_VALUE, SqlValue))
#define SQL_IS_VALUE(obj)	(G_TYPE_CHECK_INSTANCE_TYPE (obj, SQL_TYPE_VALUE))

typedef struct _SqlValue SqlValue;
typedef struct _SqlValueClass SqlValueClass;

struct _SqlValue
{
	SqlExpr parent;
	GValue * value;
	GvnParam * param;
};

struct _SqlValueClass
{
	/* <private> */
	SqlExprClass parent;
};

GType			sql_value_get_type			();
SqlObject *		sql_value_new				();
SqlObject *		sql_value_new_with_value	(const GValue * value);
const GValue *	sql_value_get_value			(SqlValue * obj);
void			sql_value_set_value			(SqlValue * obj, const GValue * value);
void			sql_value_set_param			(SqlValue * obj, GvnParam * param);

#endif
