/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VN_COLUMN_COMBO_H
#define VN_COLUMN_COMBO_H

#include <vn/vn-column.h>

#define VN_TYPE_COLUMN_COMBO			(vn_column_combo_get_type ())
#define VN_COLUMN_COMBO(obj)			(G_TYPE_CHECK_INSTANCE_CAST (obj, VN_TYPE_COLUMN_COMBO, VnColumnCombo))
#define VN_IS_COLUMN_COMBO(obj)			(G_TYPE_CHECK_INSTANCE_TYPE (obj, VN_TYPE_COLUMN_COMBO))
#define VN_COLUMN_COMBO_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST (klass, VN_TYPE_COLUMN_COMBO, VnColumnComboClass))
#define VN_IS_COLUMN_COMBO_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE (klass, VN_TYPE_COLUMN_COMBO))
#define VN_COLUMN_COMBO_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS (obj, VN_TYPE_COLUMN_COMBO, VnColumnComboClass))

typedef struct _VnColumnCombo VnColumnCombo;
typedef struct _VnColumnComboClass VnColumnComboClass;

struct _VnColumnCombo
{
	VnColumn parent;
	/* <private> */
	DbModel * model;
	GtkTreeModel * tree_model;
	guint index_column;
	guint show_column;
	GtkEntryCompletion * completion;
	gboolean completion_ready;
	GtkCellEditable * editable;
};

struct _VnColumnComboClass
{
	/* <private> */
	VnColumnClass parent;
};

GType	vn_column_combo_get_type	();

#endif